<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00057001ConfiguracaoRegionalIdiomaService;
use SM\Traits\TResponse;

class Sm00057001ConfiguracaoRegionalIdiomaController extends SMCrud
{

    use TResponse;

    protected $Sm00057001ConfiguracaoRegionalIdiomaService;

    public function __construct($crudService, $environment, Sm00057001ConfiguracaoRegionalIdiomaService $Sm00057001ConfiguracaoRegionalIdiomaService)
    {
        parent::__construct($crudService, $environment);
        $this->Sm00057001ConfiguracaoRegionalIdiomaService = $Sm00057001ConfiguracaoRegionalIdiomaService;
    }

    public function getConfiguracaoRegionalIdioma()
    {
        try {
            $data = $this->Sm00057001ConfiguracaoRegionalIdiomaService->getConfiguracaoRegionalIdioma();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirConfiguracaoRegionalIdioma(DTO\Request $request)
    {
        try {
            $this->Sm00057001ConfiguracaoRegionalIdiomaService->inserirConfiguracaoRegionalIdioma($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarConfiguracaoRegionalIdioma(DTO\Request $request)
    {
        try {
            $this->Sm00057001ConfiguracaoRegionalIdiomaService->deletarConfiguracaoRegionalIdioma($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
