<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00057002ConfiguracaoRegionalMoedaService;
use SM\Traits\TResponse;

class Sm00057002ConfiguracaoRegionalMoedaController extends SMCrud
{

    use TResponse;

    protected $Sm00057002ConfiguracaoRegionalMoedaService;

    public function __construct($crudService, $environment, Sm00057002ConfiguracaoRegionalMoedaService $Sm00057002ConfiguracaoRegionalMoedaService)
    {
        parent::__construct($crudService, $environment);
        $this->Sm00057002ConfiguracaoRegionalMoedaService = $Sm00057002ConfiguracaoRegionalMoedaService;
    }

    public function getConfiguracaoRegionalMoeda()
    {
        try {
            $data = $this->Sm00057002ConfiguracaoRegionalMoedaService->getConfiguracaoRegionalMoeda();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function validaConfiguracaoRegionalMoeda(Request\Row $request, Response $response)
    {

        $row = $request->getRow();

        $moeda = $row['NMMOEDA'];

        $dtsValConfigMoeda = new DataSet('VALIDAMOEDA', array('VALIDA' => $validaConfigRegionalMoeda));

        $response->addDataSet($dtsValConfigMoeda);
    }

    public function inserirConfiguracaoRegionalMoeda(DTO\Request $request)
    {
        try {
            $configuracaoRegionalMoedas = $this->Sm00057002ConfiguracaoRegionalMoedaService->inserirConfiguracaoRegionalMoeda($request->getParameters());
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarConfiguracaoRegionalMoeda(DTO\Request $request)
    {
        try {
            $configuracaoRegionalMoedas = $this->Sm00057002ConfiguracaoRegionalMoedaService->deletarConfiguracaoRegionalMoeda($request->getParameters());
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
