<?php

namespace SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctAtualizaDocumento
{
    
    const NOME = "FCT_ATUALIZA_DOCUMENTO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqcontrato
     * @param string  $operador
     * @param integer $nrorg
     */
    public function executar($codigo, $tipo, $documento, $nrorg, $operador) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_CODIGO",    Param::PARAM_INPUT,  $codigo,    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_TIPO",      Param::PARAM_INPUT,  $tipo,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DOCUMENTO", Param::PARAM_INPUT,  $documento, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",     Param::PARAM_INPUT,  $nrorg,     Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_OPERADOR",  Param::PARAM_INPUT,  $operador,  Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
}

?>

