/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_FORMULARIONF' AND
                 TYPE   = 'TR' 		             AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_FORMULARIONF
GO


CREATE TRIGGER LOG_GER_FORMULARIONF
ON FORMULARIONF
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO          VARCHAR(40);
   DECLARE  @V_TIPO             VARCHAR(1);
   DECLARE  @V_ITPESQ           VARCHAR(40);
   DECLARE  @V_DESC             VARCHAR(300);
   DECLARE  @V_DTOPER           DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO     VARCHAR(1);

   DECLARE  @V_CDCTRLNUMENF_OLD  VARCHAR(10);
   DECLARE  @V_NRFORMULARNF_OLD  VARCHAR(20);
   DECLARE  @V_CDFILIAL_OLD      VARCHAR(4);
   DECLARE  @V_NRLANCTONF_OLD    VARCHAR(10);
   DECLARE  @V_IDSTATUSFORM_OLD  VARCHAR(1);
   DECLARE  @V_NRCTRLFORMNF_OLD  VARCHAR(10);

   DECLARE  @V_CDCTRLNUMENF_NEW VARCHAR(10);
   DECLARE  @V_NRFORMULARNF_NEW VARCHAR(20);
   DECLARE  @V_CDFILIAL_NEW     VARCHAR(4);
   DECLARE  @V_NRLANCTONF_NEW   VARCHAR(10);
   DECLARE  @V_IDSTATUSFORM_NEW VARCHAR(1);
   DECLARE  @V_NRCTRLFORMNF_NEW VARCHAR(10);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');
   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDCTRLNUMENF,
      NRFORMULARNF,
      CDFILIAL,
      NRLANCTONF,
      IDSTATUSFORM,
      NRCTRLFORMNF,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      CDCTRLNUMENF+NRCTRLFORMNF+NRFORMULARNF NOT IN (SELECT CDCTRLNUMENF+NRCTRLFORMNF+NRFORMULARNF FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
      DELETED.CDCTRLNUMENF,
      DELETED.NRFORMULARNF,
      DELETED.CDFILIAL,
      DELETED.NRLANCTONF,
      DELETED.IDSTATUSFORM,
      DELETED.NRCTRLFORMNF,
      INSERTED.CDCTRLNUMENF,
      INSERTED.NRFORMULARNF,
      INSERTED.CDFILIAL,
      INSERTED.NRLANCTONF,
      INSERTED.IDSTATUSFORM,
      INSERTED.NRCTRLFORMNF
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDCTRLNUMENF = DELETED.CDCTRLNUMENF   AND
      INSERTED.NRCTRLFORMNF = DELETED.NRCTRLFORMNF   AND
      INSERTED.NRFORMULARNF = DELETED.NRFORMULARNF

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDCTRLNUMENF,
      NRFORMULARNF,
      CDFILIAL,
      NRLANCTONF,
      IDSTATUSFORM,
      NRCTRLFORMNF
   FROM
      INSERTED
   WHERE
      CDCTRLNUMENF+NRCTRLFORMNF+NRFORMULARNF NOT IN (SELECT CDCTRLNUMENF+NRCTRLFORMNF+NRFORMULARNF FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDCTRLNUMENF_OLD,
                                 @V_NRFORMULARNF_OLD,
                                 @V_CDFILIAL_OLD,
                                 @V_NRLANCTONF_OLD,
                                 @V_IDSTATUSFORM_OLD,
                                 @V_NRCTRLFORMNF_OLD,

                                 @V_CDCTRLNUMENF_NEW,
                                 @V_NRFORMULARNF_NEW,
                                 @V_CDFILIAL_NEW,
                                 @V_NRLANCTONF_NEW,
                                 @V_IDSTATUSFORM_NEW,
                                 @V_NRCTRLFORMNF_NEW;



   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_DESC = '';
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDCTRLNUMENF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_OLD;
         END;

         IF @V_NRCTRLFORMNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CtrlForm=' + @V_NRCTRLFORMNF_OLD;
         END;

         IF @V_NRFORMULARNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrFormul=' + @V_NRFORMULARNF_OLD;
         END;

         IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + '  Filial=' + @V_CDFILIAL_OLD;
         END;

         IF @V_NRLANCTONF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrLancaNF=' + @V_NRLANCTONF_OLD;
         END;

         IF @V_IDSTATUSFORM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Status=' + @V_IDSTATUSFORM_OLD;
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_CDCTRLNUMENF_OLD + @V_NRCTRLFORMNF_OLD + @V_NRFORMULARNF_OLD;
      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_CDCTRLNUMENF_OLD <> @V_CDCTRLNUMENF_NEW)  OR
            (@V_NRCTRLFORMNF_OLD <> @V_NRCTRLFORMNF_NEW)  OR
            ISNULL(@V_NRFORMULARNF_NEW,'!') <> ISNULL(@V_NRFORMULARNF_OLD,'!') OR
            ISNULL(@V_CDFILIAL_NEW,'!')     <> ISNULL(@V_CDFILIAL_OLD,'!') OR
            ISNULL(@V_NRLANCTONF_NEW,'!')   <> ISNULL(@V_NRLANCTONF_OLD,'!') OR
            ISNULL(@V_IDSTATUSFORM_NEW,'!') <> ISNULL(@V_IDSTATUSFORM_OLD,'!') BEGIN

            SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_NEW;
            SET @V_DESC = @V_DESC + ' CtrlForm=' + @V_NRCTRLFORMNF_NEW;
            SET @V_DESC = @V_DESC + ' NrFormul=' + @V_NRFORMULARNF_NEW;
            SET @V_DESC = @V_DESC + '  Filial=' + @V_CDFILIAL_NEW;
            SET @V_DESC = @V_DESC + ' NrLancaNF=' + @V_NRLANCTONF_NEW;
            SET @V_DESC = @V_DESC + ' Status=' + @V_IDSTATUSFORM_NEW;
            SET @V_TIPO         = '2';
            SET @V_ITPESQ       = @V_CDCTRLNUMENF_OLD + @V_NRCTRLFORMNF_OLD + @V_NRFORMULARNF_OLD;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_CDCTRLNUMENF_NEW + @V_NRCTRLFORMNF_NEW + @V_NRFORMULARNF_NEW;
      END;
       IF @V_CDCTRLNUMENF_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_NEW;
       END;

       IF @V_NRCTRLFORMNF_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' CtrlForm=' + @V_NRCTRLFORMNF_NEW;
       END;

       IF @V_NRFORMULARNF_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' NrFormul=' + @V_NRFORMULARNF_NEW;
       END;

       IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + '  Filial=' + @V_CDFILIAL_NEW;
       END;

       IF @V_NRLANCTONF_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' NrLancaNF=' + @V_NRLANCTONF_NEW;
       END;

       IF @V_IDSTATUSFORM_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Status=' + @V_IDSTATUSFORM_NEW;
       END;
       IF @V_TIPO <> '0' BEGIN
          EXEC NMUSUARIO @V_USUARIO;
          IF NOT @V_DESC IS NULL BEGIN
             IF NOT @V_USUARIO IS NULL BEGIN
                SET @V_DTOPER = GETDATE();

                INSERT INTO LOGOPERA
                   (NMTABELA,   DTOPERACAO, NMRESPOPER,
                    IDTIPOOPER, CDPESQITEM, DSOPERACAO)
                VALUES
                   ('FORMULARIONF',  @V_DTOPER, @V_USUARIO,
                    @V_TIPO,      @V_ITPESQ, @V_DESC);
             END;
          END;
       END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDCTRLNUMENF_OLD,
                                    @V_NRFORMULARNF_OLD,
                                    @V_CDFILIAL_OLD,
                                    @V_NRLANCTONF_OLD,
                                    @V_IDSTATUSFORM_OLD,
                                    @V_NRCTRLFORMNF_OLD,
                                    @V_CDCTRLNUMENF_NEW,
                                    @V_NRFORMULARNF_NEW,
                                    @V_CDFILIAL_NEW,
                                    @V_NRLANCTONF_NEW,
                                    @V_IDSTATUSFORM_NEW,
                                    @V_NRCTRLFORMNF_NEW;



   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_FORMULARIONF','4.11.105';
GO

